//==============================================================================
// простой барограф-4
//==============================================================================
extern "C"
{ void minit(void);     // инициализация портов и пр.
  void mslipping(void); // работа в экономичном режиме
  unsigned char getADC8(unsigned char nomeradc);
  unsigned char mknopki(void);
}

#include "Adafruit_GFX.h"    // Core graphics library
#include "Adafruit_ST7735.h" // Hardware-specific library
#include <SPI.h>

#define TFT_CS     8
#define TFT_RST    9
#define TFT_DC     10

// включим аппаратный SPI,
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

#define TFT_SCLK 13   // set these to be whatever pins you like!
#define TFT_MOSI 11   // set these to be whatever pins you like!
// но можно включить программный
//Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_MOSI, TFT_SCLK, TFT_RST);

#include <Wire.h>
#include "Adafruit_BMP085.h"
Adafruit_BMP085 bmp;

unsigned char chas = 0, mins = 1, sec = 54; // время
volatile unsigned char temper = 0;  // теммпература
volatile unsigned char dawlenie = 0;// крайнее измеренное
unsigned char dawl[409];  // массив значений давления 4 суток = 48*4 = 192+хвост

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
unsigned char
  oldregim  = 0,  // предыдущее значение
  regim     = 0;  // текущее значение

//==============================================================================
void setup(void)
{
  minit();  // всеобщая инициализация

  if (!bmp.begin())
  { 
    while (1) {}
  }
  
// начальное заполнение массива - "пила" на экране
  unsigned int i = 0;
  for (i = 0; i < 409; i++) dawl[i] = 2*(i%48)+25;
}
//==============================================================================
// работа с датчиком
void datchik(void)
{ unsigned int i = 0;
  if (((mins ==  2) && (sec == 10))||((mins == 32) && (sec == 10)))
  { temper = bmp.readTemperature();
    
    for (i = 1; i < 409; i++)
    { dawl[i - 1] = dawl[i];
    }

// ограничитель сверху и снизу
// считаем, что давления ниже 700 и выше 775 не бывает.
// для большинства местностей так и есть. 
    unsigned int tmp = (bmp.readPressure() - 93332);  // вычитаем 700 миллиметров
    dawlenie = tmp*3/400;   // значение, выводимое цифрами на экран
// 400/3 = 133,333 - но можно не использовать числа с плавающей запятой

// теперь сделаем ограничитель для графика. 
// точки на графике рисуются не ниже 710 и не выше 770 миллиметров.
    if (tmp < 1333) tmp = 1333;
    if (tmp > 9333) tmp = 9333;
    
    dawl[408] = tmp*3/160-16;   // переводим в пиксели  160/3 = 53,33

    delay(1000);      // задержка против повторения опроса
    if (regim == 1)   // 1 - питание наличествует
    { grafik();
    }
  }
}
//==============================================================================
void loop()
{
  datchik();

  if (PINC & (1<<PC2))	// питание есть
  {
    if (oldregim == 0)  // если питание от сети только что включилось
    {
      tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
      ekran0();
      grafik();
    }

    regim = 1;	//

    showtime();
    delay(50);
    if (mknopki() == 1) // если была нажата кнопка
    { showtime();
      delay(200);
    }
  }
  else                  // питание отсутствует
  { regim = 0;
    mslipping();        // "спящий" режим
  }

  oldregim = regim;
}
//==============================================================================
