//==============================================================================
// вся графика
//==============================================================================
#define putstr(x,y,sizing,color,backcolor,str) \
      tft.setCursor(x,y);\
      tft.setTextSize(sizing);\
      tft.setTextColor(color,backcolor);\
      tft.print(str)
      
// чтобы не писать длинные названия цветов
#define RED     ST7735_RED
#define GREEN   ST7735_GREEN
#define BLUE    ST7735_BLUE
#define WHITE   ST7735_WHITE
#define YELLOW  ST7735_YELLOW
#define GRAY1   0b0111101111101111
#define CYAN   	0b0000001111101111

#define gBACK   3   // тёмно-темно-синий фон

unsigned char gdedawl = 7;    // где рисовать давление (7-наверху, 100-внизу)

//==============================================================================
// формируем начальную картинку
void ekran0(void)
{ tft.setRotation(0);
  tft.fillScreen(gBACK);         // тёмно-тёмносиний
//--------------------------------- шкала -------
  unsigned char i = 0, j = 0;
  String str = "700";  
  tft.drawLine(0,0,127,0,WHITE);  // верхняя горизонталь
  i = 6;
  for (j = 25; j < 130; j+= 25)
  { tft.drawLine(110,j,127,j,GRAY1);
    str[1] = i + '0';
    i--;
    putstr(110,j-9,1,GRAY1,gBACK,str);
  }
  tft.drawLine(0,150,127,150,WHITE);  // нижняя горизонталь
//-----------------------------------------------
  tft.drawLine( 0,0, 0,149,WHITE);   // вертикаль слева
//  tft.drawLine(98,0,98,149,WHITE);   // вертикаль справа
}
//==============================================================================
// график двухсуточный
void grafik2(unsigned char wgrafika)
{ unsigned char i = 0, j = 0;
  unsigned char tmp = 0;

  for (i = 0; i < 103; i++)
  { tft.drawLine(i+1,1, i+1, 149, gBACK); // стиралка
    if ((i == 7)||(i == 55)) tft.drawLine(i+1,1, i+1, 149, GRAY1);    // суточная линия
    for ( j = 25; j < 130; j += 25)   // горизонтальная сетка
      tft.drawPixel(i+1,j,GRAY1);
   
    tmp = dawl[i+306];

    if (wgrafika)    
      tft.drawLine(i+1,149, i+1, 159 - dawl[i+306], CYAN); // график залитый
    tft.drawPixel(i+1,159 - dawl[i+306], WHITE);  // график ОСНОВНОЙ

    if (i > 55)
    {
      if (tmp > 135) gdedawl = 100;    // где рисовать давление (7-наверху, 100-внизу)
    }                      
  
  }
} // void grafik2
//==============================================================================
// график четырехсуточный
void grafik4(unsigned char wgrafika)
{
  unsigned char i = 0,j = 0;
  unsigned char tmp = 0;
  
  for (i = 0; i < 103; i++)
  { 
    tft.drawLine(i+1,1, i+1, 149, gBACK); // стиралка
    
    if ((i == 7)||(i == 31)||(i == 55)||(i == 79)) 
      tft.drawLine(i+1,1, i+1, 149, GRAY1);    // суточная линия
    
    for (j = 25; j < 130; j += 25)   // горизонтальная сетка
      tft.drawPixel(i+1,j,GRAY1);

    tmp = dawl[2*i+204];
    
    if (wgrafika)    
       tft.drawLine(i+1,149, i+1, 159 - tmp, CYAN); // график залитый
    tft.drawPixel(i+1,159 - tmp, WHITE);  // график ОСНОВНОЙ

  	if (i > 55)
	  {
		  if (tmp > 135) gdedawl = 100;    // где рисовать давление (7-наверху, 100-внизу)
	  }                      
  }
} // void grafik4
//==============================================================================
// график восьмисуточный
void grafik8(unsigned char wgrafika)
{ unsigned char i = 0,j = 0;
  unsigned char tmp = 0;
  for (i = 0; i < 103; i++)
  { 
    tft.drawLine(i+1,1, i+1, 149, gBACK); // стиралка
    
    if ((i == 7)||(i == 19)||(i == 31)||(i == 43)||(i == 55)||(i == 67)||(i == 79)||(i == 91)) 
      tft.drawLine(i+1,1, i+1, 149, GRAY1);    // суточная линия
    
    for ( j = 25; j < 130; j += 25)   // горизонтальная сетка
      tft.drawPixel(i+1,j,GRAY1);

    tmp = dawl[4*i];
   
    if (wgrafika)    
       tft.drawLine(i+1,149, i+1, 159 - tmp, CYAN); // график залитый
    tft.drawPixel(i+1,159 - tmp, WHITE);  // график ОСНОВНОЙ

    if (i > 55)
    {
      if (tmp > 135) gdedawl = 100;    // где рисовать давление (7-наверху, 100-внизу)
    }                  
  }
} // void grafik8
//==============================================================================
void grafik(void)
{ 
  unsigned char i = 0;
  unsigned char j = 0;

  gdedawl = 7;    // где рисовать давление (7-наверху, 100-внизу)
  
  unsigned char wgrafika = 0;   // вид графика - залитый (1) или незалитый (0)

  PORTD |= (7<<PD2);
  _delay_ms(50);
  unsigned char tmp = PIND;
  PORTD &= ~(7<<PD2);

  if (tmp & (1<<PD4)) wgrafika = 1;  // залитый
  else                wgrafika = 0;  // НЕзалитый

  tmp &= (1<<PD2)|(1<<PD3);
  if (tmp == 0)                       grafik2(wgrafika);
  else if (tmp == (1<<PD2))           grafik2(wgrafika);
  else if (tmp == (1<<PD3))           grafik4(wgrafika);
  else if (tmp == (1<<PD2)|(1<<PD3))  grafik8(wgrafika);
  
//----------------------------------------- КРАСНЫЙ СТОЛБИК 
  for (i = 104; i < 109; i++)
  { tft.drawLine(i,  1,i,149,gBACK);
    tft.drawLine(i,148,i,159-dawl[408],RED);
  }
//--------------------------------------------- ТЕМПЕРАТУРА
  String str = "T=+000C";
  str[3] = (temper / 10) + '0';
  str[4] = (temper % 10) + '0';
  str[5] = 247;
  putstr(74,153,1,WHITE,gBACK,str);
//------------------------------------------------ ДАВЛЕНИЕ
  str = "777";
  str[1] = (dawlenie / 10) + '0';
  str[2] = (dawlenie % 10) + '0';
  putstr(62,gdedawl,2,GREEN,gBACK,str);
}
//==============================================================================
// вывод времени
void showtime(void)
{ String str = "00:00:00";
  str[0] = (chas / 10) + '0';
  str[1] = (chas % 10) + '0';
  str[3] = (mins / 10) + '0';
  str[4] = (mins % 10) + '0';
  str[6] = (sec / 10)  + '0';
  str[7] = (sec % 10)  + '0';
  putstr(18,153,1,YELLOW, gBACK, str);
}
//==============================================================================
